package com.jasamedika.medifirst2000.entities;

import java.io.Serializable;
import org.hibernate.envers.Audited;
import javax.persistence.*;

import org.hibernate.validator.constraints.NotEmpty;

import com.jasamedika.medifirst2000.base.BaseMaster;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.internal.util.logging.Messages;

import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.jasamedika.medifirst2000.base.BaseMaster;
import com.jasamedika.medifirst2000.helper.Caption;
import org.hibernate.envers.Audited;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

/**
 * class KomponenPemeriksaanRangeNilaiK
 * 
 * @author Generator
 */
@Entity // @Audited
@Table(name = "KomponenPemeriksaanRangeNilaiK_M")
public class KomponenPemeriksaanRangeNilaiK extends BaseMaster {
	@ManyToOne
	@JoinColumn(name = "ObjectJenisKelaminFk")
	@NotNull(message = "Kd Jenis Kelamin tidak boleh kosong")

	@Caption(value = "Object Jenis Kelamin")
	private JenisKelamin jenisKelamin;

	public void setJenisKelamin(JenisKelamin jenisKelamin) {
		this.jenisKelamin = jenisKelamin;
	}

	public JenisKelamin getJenisKelamin() {
		return this.jenisKelamin;
	}

	@Column(name = "ObjectJenisKelaminFk", insertable = false, updatable = false)
	private Integer jenisKelaminId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelompokUmurFk")
	@NotNull(message = "Kd Kelompok Umur tidak boleh kosong")

	@Caption(value = "Object Kelompok Umur")
	private KelompokUmur kelompokUmur;

	public void setKelompokUmur(KelompokUmur kelompokUmur) {
		this.kelompokUmur = kelompokUmur;
	}

	public KelompokUmur getKelompokUmur() {
		return this.kelompokUmur;
	}

	@Column(name = "ObjectKelompokUmurFk", insertable = false, updatable = false, nullable = false)
	private Integer kelompokUmurId;

	@ManyToOne
	@JoinColumn(name = "ObjectKomponenPeriksaFk")
	@NotNull(message = "Kd Komponen Periksa tidak boleh kosong")

	@Caption(value = "Object Komponen Periksa")
	private KomponenPemeriksaan komponenPeriksa;

	public void setKomponenPeriksa(KomponenPemeriksaan komponenPeriksa) {
		this.komponenPeriksa = komponenPeriksa;
	}

	public KomponenPemeriksaan getKomponenPeriksa() {
		return this.komponenPeriksa;
	}

	@Column(name = "ObjectKomponenPeriksaFk", insertable = false, updatable = false, nullable = false)
	private Integer komponenPeriksaId;

	@ManyToOne
	@JoinColumn(name = "ObjectMetodePeriksaFk")
	@NotNull(message = "Kd Metode Periksa tidak boleh kosong")

	@Caption(value = "Object Metode Periksa")
	private MetodePemeriksaanPenunjang metodePeriksa;

	public void setMetodePeriksa(MetodePemeriksaanPenunjang metodePeriksa) {
		this.metodePeriksa = metodePeriksa;
	}

	public MetodePemeriksaanPenunjang getMetodePeriksa() {
		return this.metodePeriksa;
	}

	@Column(name = "ObjectMetodePeriksaFk", insertable = false, updatable = false, nullable = false)
	private Integer metodePeriksaId;

	@NotNull(message = "Keterangan Range Nilai tidak boleh kosong")
	@Column(name = "KeteranganRangeNilai", nullable = false, length = 150)
	@Caption(value = "Keterangan Range Nilai")
	private String keteranganRangeNilai;

	public void setKeteranganRangeNilai(String keteranganRangeNilai) {
		this.keteranganRangeNilai = keteranganRangeNilai;
	}

	public String getKeteranganRangeNilai() {
		return this.keteranganRangeNilai;
	}

	@NotNull(message = "No Urut tidak boleh kosong")
	@Column(name = "NoUrut", nullable = false)
	@Caption(value = "No Urut")
	private Byte noUrut;

	public void setNoUrut(Byte noUrut) {
		this.noUrut = noUrut;
	}

	public Byte getNoUrut() {
		return this.noUrut;
	}

	@Id
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "public.komponenpemeriksaanrangenilaik_m_id_seq")
	@javax.persistence.SequenceGenerator(name = "public.komponenpemeriksaanrangenilaik_m_id_seq", sequenceName = "public.komponenpemeriksaanrangenilaik_m_id_seq", allocationSize = 1)
	@Column(name = "id")
	protected Integer id;

	public Integer getId() {

		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}
}